;; pdfAID.lsp

;; 2024.09.06 IMPORTPDF R}h߁iPDFAID.EXE ŉ]pxɑΉ߁j
;; 2024.09.05 PDFLINE Œ_3ȉ̃|C̕ǉARgAEg
;; 2024.05.04 CRCUT ł UNDO, G[΍ǉ
;;            oneLine ǉ
;;            txlines ǉ
;; 2024.04.25 PDFLINE _5 ɑΉ
;; 2024.04.24 PDFAID FׂĔɂǉ
;; 2024.01.23 

;; CRCut : SPLINE ŃJbgȂ̂΍
;; ZWCAD  LWPORYLINE 쐬Ȃ̂΍
;; lnAlp sSȌr𐮌`ǉ
;; ~̃nb`O̗֊sdɍ쐬̂蒼

;; pdfAID ̑̔r
;; BricsCAD V19 1 sec, BricsCAD V24 2 sec
;; IJCAD 2023 11 sec, GstarCAD 2024 2.2 sec
;; ZWCAD 2023 5.7 sec

;; R}h
;; pdfAID  : PDFIMPORT ō쐬ꂽ SOLIDAHATCHAꕶ폜
;; pdfLINE : SOLID  RECT(LWPOLYLINE) ɕϊꂽ\̎d؂ LINE ɕϊ
;;           _3ȉ̃|C͖

;; lnAlp   : sSȁi[_ȂĂȂjr𐮌`
;; CRCut   : CIRCLE, ELLIPSE, LWPOLYLINE Ɍ LINE, POLYLINE Jbg
;; oneLine : pdfLINE ŐłȂ|CA
;;           SPLINE, ELLIPSE ͖ō폜̂ŁAƂɑI
;; txlines : s TEXT, MTEXT iMTEXT͕j

(vl-load-com)
(defun ifs_pointW (pt off /) 
  (list 
    (list (- (car pt) off) (- (cadr pt) off) 0.0)
    (list (+ (car pt) off) (+ (cadr pt) off) 0.0)
  )
)
;; vle-string-replace 
(defun ifs_string_replace (newStr oldStr inStr / lastStr) 
  (while (/= lastStr inStr) 
    (setq lastStr inStr)
    (setq inStr (vl-string-subst newStr oldStr inStr))
  )
  inStr
)
;; IZbg`͈͂𓾂
;; ȂƂ nil Ԃ
;; ex: fil = "*LINE,CIRCLE,ARC"
(defun ifs_getSSRect (ss fil / i len maxPt maxVpt minPt minVpt result ret xLst yLst 
                      ename ent etype
                     ) 
  ;;(princ "\nfunc ifs_getSSRect")
  (setq len    (sslength ss)
        i      0
        result nil
  )
  ;;(princ "\nlen=")(princ len)
  (repeat len 
    (setq ename (ssname ss i)
          ent   (entget ename)
          etype (cdr (assoc 0 ent))
    )
    (if (wcmatch etype fil) 
      (progn 
        ;; AutoCAD ł́A(vlax-ename->vla-object ename) ŃG[ɂȂ
        (vla-getboundingbox (vlax-ename->vla-object ename) 'minVpt 'maxVpt)
        (setq minPt (vlax-safearray->list minVpt)
              maxPt (vlax-safearray->list maxVpt) ;;
              xLst  (append xLst (list (car minPt) (car maxPt)))
              yLst  (append yLst (list (cadr minPt) (cadr maxPt)))
        )
      )
    )
    (setq i (1+ i))
  )
  (if (and xlst ylst) 
    (setq minPt (list (apply 'min xLst) (apply 'min yLst) 0)
          maxPt (list (apply 'max xLst) (apply 'max yLst) 0)
          ret   (not (equal minPt maxPt 0.0001))
    )
  )
  (if ret 
    (setq result (list minpt maxpt))
  )
  result
)
;; solid 4_ 擾AWXgԂ
(defun func_solidxx (ename chkFlag / cnt code ent j lst pts ss1 plcnt code10lst) 
  (setq ent   (entget ename)
        plcnt 0
  )
  (if chkFlag 
    (progn 
      (setq code 10
            lst  nil
            j    0
            cnt  0
      )
      (repeat 4 
        (setq lst (append lst (list (cdr (assoc code ent)))))
        (setq code (1+ code))
      )
      (repeat 4 
        (setq pts (ifs_pointW (nth j lst) 0.05))
        (if (setq ss1 (ssget "C" (car pts) (cadr pts) '((0 . "LWPOLYLINE")))) 
          (if (> (sslength ss1) 0) 
            (setq cnt (1+ cnt))
          )
        )
        (setq j (1+ j))
      )
      (if (< cnt 4) 
        (progn 
          (if (not (equal (nth 2 lst) (nth 3 lst) 0.0001)) 
            (setq code10lst (list (nth 0 lst) (nth 1 lst) (nth 3 lst) (nth 2 lst)))
            (setq code10lst (list (nth 0 lst) (nth 1 lst) (nth 3 lst)))
          )
        )
      )
    )
  )
  (entdel ename)
  code10lst
)

;; ł HATCH ̗֊sۂ}`邩
(defun func_hatchxx (ename / code ent i len lst xmin xmax ymin ymax dist ssrect 
                     ssarea box boxarea fil xlst ylst mkflag
                    ) 
  (setq mkflag T)
  (setq ent (entget ename)
        len (length ent)
        i   0
  )
  ;;_
  (repeat len 
    (setq code (car (nth i ent)))
    (if (or (= code 10) (= code 11)) 
      (setq lst (append lst (list (cdr (nth i ent)))))
    )
    (setq i (1+ i))
  )
  ;; _͂`̒ɐ}`邩
  (if (and lst (> (setq len (length lst)) 1)) 
    (progn 
      (setq xmin 0.0
            xmax 0.0
            ymin 0.0
            ymax 0.0
            dist 0.0
            i    1
      )
      (repeat (1- len) 
        (setq xlst (append xlst (list (car (nth i lst))))
              ylst (append ylst (list (cadr (nth i lst))))
        )
        (setq i (1+ i))
      )
      (if xlst 
        (setq xmin (apply 'min xlst)
              xmax (apply 'max xlst)
        )
      )
      (if ylst 
        (setq ymin (apply 'min ylst)
              ymax (apply 'max ylst)
        )
      )
      (setq dist (distance (list xmin ymin) (list xmax ymax)))
      (if (and (> (- xmax xmin) 0.1) (> (- ymax ymin) 0.1) (> dist 0.0)) 
        (progn 
          ;; ]T݂O̖ʐ
          (setq ssarea (* (- xmax xmin) (- ymax ymin)))
          (setq xmin (- xmin 0.2)
                xmax (+ xmax 0.2)
          )
          (setq ymin (- ymin 0.2)
                ymax (+ ymax 0.2)
          )
          ;;(command "_rectang" "none" (list xmin ymin) "none" (list xmax ymax) )
          (setq fil "*LINE,CIRCLE,ARC,ELLIPSE")
          ;; _͈̔͂̏Ő`̐}`擾
          (if 
            (setq ssrect (ssget "W" 
                                (list xmin ymin)
                                (list xmax ymax)
                                (list (cons 0 fil))
                         )
            )
            (progn 
              ;;(setq ssarea (* (- xmax xmin)(- ymax ymin)))
              ;; ͈͓̔̐}`͂`擾
              (if (setq box (ifs_getSSRect ssrect fil));; AutoCAD ł̓G[ɂȂ 
                (progn 
                  (setq boxarea (* (- (car (cadr box)) (car (car box))) 
                                   (- (cadr (cadr box)) (cadr (car box)))
                                )
                  )
                  ;; ʐϔ 75% 菬́AHATCHGENERATEBOUNDARY s
                  (setq mkflag (< (/ boxarea ssarea) 0.75))
                  ;;(princ (/ boxarea ssarea))
                  ;;(command "_rectang" "none" (car box) "none" (cadr box))
                )
              )
            )
          )
        )
      )
    )
  )
  mkflag
)
; (defun c:SPLxx( /  i len ss)
;   (if (setq ss (ssget '((0 . "SPLINE"))))
;     (progn
;       ;;(command "_CHPROP" ss "" "c" 7 "");; 2024.04.24
;       (setq len (sslength ss) i 0)
;       (repeat len
;         (command "_SPLINEDIT" (ssname ss i) "p" 10 "")
;         (setq i (1+ i))
;       )
;     )
;   )
;   (princ)
; )
;; PDFIMPORT ō쐬ꂽ SOLIDAHATCH obT폜
;; ꕶ͍폜
(defun do_pdfAID (xflag / p1 p2 ename ent i len name ss str str1 lwpcnt bndcnt repcnt ticks 
                 lwplst lst j len2 mklst
                ) 
  (setq lwpcnt 0
        bndcnt 0
        repcnt 0
  )
  (if (not xflag)
    (if (setq p1 (getpoint "\nIR[i[1_ڂw : ")) 
      (if (setq p2 (getcorner p1 "\n2_ڂw : ")) 
        (setq ss (ssget "W" p1 p2 '((0 . "SOLID,HATCH,*TEXT"))))
      )
    )
    (setq ss (ssget "x" '((0 . "SOLID,HATCH,*TEXT"))))
  )
  (if ss 
    (progn 
      (setq ticks (getvar "DATE"))
      ;;(setq vctr (getvar "viewctr"))
      ;;(setq vsize (getvar "viewsize"))

      (setvar "CMDECHO" 0)
      (command "_UNDO" "BE")
      ;;(command "_CHPROP" ss "" "c" 7 "");; 2024.04.24
      (setq len (sslength ss)
            i   0
      )
      (repeat len 
        (setq ename (ssname ss i)
              ent   (entget ename)
        )
        (setq name (cdr (assoc 0 ent)))
        (cond 
          ((= name "SOLID")
           ;; 쐬 LWP WXg SOLID ͍폜
           (setq lwplst (append lwplst (list (func_solidxx ename T))))
          )
          ;; SPLINE, LINE ɕϊ
          ((= name "HATCH")
            (progn
              ;; HATCH ̗֊s邩
              ;;(if (func_hatchxx ename) ;; 2024/09/06 RgAEg
                (setq mklst (append mklst (list ename)))
              ;;)
            )
          )
          ;; ꕶ폜
          ((wcmatch name "*TEXT")
           (progn 
             (setq str (cdr (assoc 1 ent)))
             (setq str1 (ifs_string_replace "" (chr 65533) str)) ;; bRICScad
             (setq str1 (ifs_string_replace "" "\\U+FFFD" str1)) ;; IJCAD
             (if (/= str str1) 
               (progn 
                 (entmod (subst (cons 1 str1) (assoc 1 ent) ent))
                 (setq repcnt (1+ repcnt))
               )
             )
           )
          )
          ; ((= name "SPLINE")
          ;   (progn
          ;     (command "_SPLINEDIT" ename "p" 10 "")
          ;   )
          ; )
        )
        (setq i (1+ i))
      )

      ;; HATCH ̗֊s쐬
      (if mklst 
        (progn 
          (setq len (length mklst)
                i   0
          )
          (repeat len 
            (setq bndcnt (1+ bndcnt))
            (command "_HATCHGENERATEBOUNDARY" (nth i mklst) "")
            (setq i (1+ i))
          )
        )
      )

      ;; ̌ HATCH 폜
      (setq len (sslength ss)
            i   0
      )
      (repeat len 
        (setq ename (ssname ss i)
              ent   (entget ename)
        )
        (setq name (cdr (assoc 0 ent)))
        (if (= name "HATCH") (entdel ename))
        (setq i (1+ i))
      )

      ;; SOLID  4 _ LWPOLYLINE 쐬
      (if lwplst 
        (progn 
          (setq len (length lwplst)
                i   0
          )
          ; (setq co (strcase (getvar "CECOLOR")))
          ; (cond
          ;   ((= co "BYLAYER")(setq code62 256))
          ;   ((= co "BYBLOCK")(setq code62 0))
          ;   (T (setq code62 (atoi co)))
          ; )
          (repeat len 
            (if (setq lst (nth i lwplst)) 
              (progn 

                (setq lwpcnt (1+ lwpcnt))
                (setq len2 (length lst)
                      j    0
                )
                (if (= len2 4) 
                  (command "_PLINE" 
                           "none"
                           (nth 0 lst)
                           "none"
                           (nth 1 lst)
                           "none"
                           (nth 2 lst)
                           "none"
                           (nth 3 lst)
                           "C"
                  )
                )
                (if (= len2 3) 
                  (command "_PLINE" 
                           "none"
                           (nth 0 lst)
                           "none"
                           (nth 1 lst)
                           "none"
                           (nth 2 lst)
                           "C"
                  )
                )
                ; (setq ent '((0 . "LWPOLYLINE")));; model(67=0)
                ; (setq ent (append ent (list
                ;                         (cons 67 0)
                ;                         (cons 8 (getvar "CLAYER"))
                ;                         (cons 6 (getvar "CELTYPE"))
                ;                         (cons 62 code62)
                ;                         (cons 90 len2)
                ;                         (cons 70 1)))
                ; )
                ; (repeat len2
                ;   (setq ent (append ent (list (cons 10 (list (car (nth j lst)) (cadr (nth j lst)))))))
                ;   (setq ent (append ent (list (cons 40 0.0)(cons 41 0.0)(cons 43 0.0))))
                ;   (setq j (1+ j))
                ; )
                ; (entmake ent)
              )
            )
            (setq i (1+ i))
          )
        )
      )
      (if (and p1 p2) 
        (if (setq ss (ssget "W" p1 p2)) 
          (command "_CHPROP" ss "" "c" 7 "") ;; 2024.04.24
        )
      )
      ;;(command "_zoom" "c" vctr vsize)
      (command "_UNDO" "END")
      (setvar "CMDECHO" 1)
      (princ "\n")
      (princ (rtos (* (- (getvar "DATE") ticks) 60 60 24) 2 1))
      (princ " sec")
    )
  )
  (princ 
    (strcat "\n" 
            (itoa bndcnt)
            "  HATCH ̗֊s쐬A "
            (itoa lwpcnt)
            "  SOLID ̗֊s쐬A "
            (itoa repcnt)
            " ̓ꕶ폜܂B"
    )
  )
  (princ)
)
(defun c:pdfAID()
  (do_pdfaid nil)
  (princ)
)
(defun c:pdfAIDX()
  (do_pdfaid T)
  (princ)
)



(defun ifs_midPoint (p1 p2 / x) 
  (mapcar '(lambda (x) (/ x 2.0)) (mapcar '+ p1 p2))
)
(defun ifs_inArea (pt minPt maxPt) 
  (and 
    (>= (car pt) (car minPt))
    (<= (car pt) (car maxPt))
    (>= (cadr pt) (cadr minPt))
    (<= (cadr pt) (cadr maxPt))
  )
)
;; SOLID  RECT(LWPOLYLINE) ɕϊꂽ\̎d؂ LINE ɕς
;; 2024.04.25 _ 5 ɑΉ
;; 2024.09.05 _ 3 ȉ͕ǉ

(defun c:pdfLINE (/ dif ss len i ename ent lst d1 d2 j len2 pts xlst ylst p1 p2 co 
                  code62
                 ) 
  (if (not (setq dif (getdist "\nג RECTANGLE rƂ݂Ȃő̕ < 0.8 > : "))) 
    (setq dif 0.8)
  )
  ;;(setvar "cmdecho" 0)
  (if (setq ss (ssget '((0 . "LWPOLYLINE")))) 
    (progn 
      (setq co (strcase (getvar "CECOLOR")))
      (cond 
        ((= co "BYLAYER") (setq code62 256))
        ((= co "BYBLOCK") (setq code62 0))
        (T (setq code62 (atoi co)))
      )
      (setq len (sslength ss)
            i   0
      )
      (repeat len 
        (setq ename (ssname ss i)
              ent   (entget ename)
        )
        (setq len2 (length ent)
              j    0
              lst  nil
        )
        (repeat len2 
          (if (= 10 (car (nth j ent))) 
            (setq lst (append lst (list (cdr (nth j ent)))))
          )
          (setq j (1+ j))
        )
        ;;2024.04.25 ǉ
        (if (= 5 (length lst)) 
          (if (equal (nth 0 lst) (nth 4 lst) 10e-4) 
            (setq lst (cdr lst))
          )
        )
        (if (and lst (= 4 (length lst))) 
          (progn 
            (setq pts nil)
            (setq d1 (distance (nth 0 lst) (nth 1 lst)))
            (setq d2 (distance (nth 1 lst) (nth 2 lst)))
            (if (<= d1 dif) 
              (setq pts (list (ifs_midpoint (nth 0 lst) (nth 1 lst)) 
                              (ifs_midpoint (nth 2 lst) (nth 3 lst))
                        )
              )
              (if (<= d2 dif) 
                (setq pts (list (ifs_midpoint (nth 1 lst) (nth 2 lst)) 
                                (ifs_midpoint (nth 3 lst) (nth 0 lst))
                          )
                )
              )
            )
            (if pts 
              (progn 
                (setq p1 (car pts)
                      p2 (cadr pts)
                )
                (if (equal (car p1) (car p2) 0.01) 
                  (setq xlst (append xlst (list (car p1))))
                  (if (equal (cadr p1) (cadr p2) 0.01) 
                    (setq ylst (append ylst (list (cadr p1))))
                  )
                )
                (setq ent '((0 . "LINE")))
                (setq ent (append ent 
                                  (list (cons 8 (getvar "CLAYER")) 
                                        (cons 6 (getvar "CELTYPE"))
                                        (cons 62 code62)
                                  )
                          )
                )
                (entmake (append ent (list (cons 10 p1) (cons 11 p2))))
                ;;(command "_LINE" "none" p1 "none" p2 "")
                (entdel ename)
              )
            )
          )
          ;; 2024/09/05  ǉ
          ; (if (and lst (>= 3 (length lst)))
          ;   (progn
          ;     (command "_EXPLODE" ename)
          ;   ) 
          ; )
        )
        (setq i (1+ i))
      )
      (do_lnalp xlst ylst dif)
    )
  )
  ;;(setvar "cmdecho" 1)
  (princ)
)

;; lnAlp   : sSȁi[_ȂĂȂjr LINE 𐮌`
(defun c:lnalp (/ dif ent i len p10 p11 ss xlst ylst) 
  (if (not (setq dif (getdist "\nꂽ[_̌o͈͂̍ől < 0.4 > : "))) 
    (setq dif 0.4)
  )
  (if (setq ss (ssget '((0 . "LINE")))) 
    (progn 
      (setq len  (sslength ss)
            i    0
            xlst nil
            ylst nil
      )
      (repeat len 
        (setq ent (entget (ssname ss i)))
        (setq p10 (cdr (assoc 10 ent))
              p11 (cdr (assoc 11 ent))
        )
        (if (equal (car p10) (car p11) 0.001) 
          (setq xlst (append xlst (list (car p10))))
          (if (equal (cadr p10) (cadr p11) 0.001) 
            (setq ylst (append ylst (list (cadr p10))))
          )
        )
        (setq i (1+ i))
      )
      (do_lnalp xlst ylst (* dif 2.0))
    )
  )
  (princ)
)
(defun do_lnalp (xlst ylst dif / ename ent fuz i j k len lst p10 p11 pts ss) 
  (if (and xlst ylst) 
    (progn 
      (setq fuz (* dif 0.5)) ;; rƂ덷
      (setq xlst (vl-sort xlst '<)
            ylst (vl-sort ylst '>)
      )
      (setq lst nil
            i   0
      )
      (repeat (length xlst) 
        (if (= i 0) 
          (setq lst (append lst (list (nth 0 xlst))))
          (if (> (- (nth i xlst) (last lst)) fuz) 
            (setq lst (append lst (list (nth i xlst))))
          )
        )
        (setq i (1+ i))
      )
      (setq xlst lst)
      (setq lst nil
            i   0
      )
      (repeat (length ylst) 
        (if (= i 0) 
          (setq lst (append lst (list (nth 0 ylst))))
          (if (> (- (last lst) (nth i ylst)) fuz) 
            (setq lst (append lst (list (nth i ylst))))
          )
        )
        (setq i (1+ i))
      )
      (setq ylst lst)
      (setq lst nil
            i   0
      )
      (repeat (length ylst) 
        (setq j 0)
        (repeat (length xlst) 
          (setq pts (ifs_pointw (list (nth j xlst) (nth i ylst)) fuz)) ;; ꂽ[_o͈̔
          (if (setq ss (ssget "C" (car pts) (cadr pts) '((0 . "LINE")))) 
            (progn 
              (setq len (sslength ss)
                    k   0
              )
              (repeat len 
                (setq ename (ssname ss k)
                      ent   (entget ename)
                )
                (setq p10 (cdr (assoc 10 ent))
                      p11 (cdr (assoc 11 ent))
                )
                (if (ifs_inArea p10 (car pts) (cadr pts)) 
                  (entmod 
                    (subst (cons 10 (list (nth j xlst) (nth i ylst) 0.0)) 
                           (assoc 10 ent)
                           ent
                    )
                  )
                )
                (if (ifs_inArea p11 (car pts) (cadr pts)) 
                  (entmod 
                    (subst (cons 11 (list (nth j xlst) (nth i ylst) 0.0)) 
                           (assoc 11 ent)
                           ent
                    )
                  )
                )
                (setq k (1+ k))
              )
            )
          )
          (setq j (1+ j))
        )
        (setq i (1+ i))
      )
    )
  )
)
(defun ifs_3dplist (ary / k len lst) 
  (setq k   0
        len (fix (/ (length ary) 3))
  )
  (repeat len 
    (setq lst (cons 
                (list (nth (* k 3) ary) 
                      (nth (+ (* k 3) 1) ary)
                      (nth (+ (* k 3) 2) ary)
                )
                lst
              )
    )
    (setq k (1+ k))
  )
  lst
)

;; CIRCLE, ELLIPSE, LWPOLYLINE Ɍ LINE, POLYLINE Jbg
;; 2024.01.22 ǉ
(defun c:crcut (/ ss len i ename obj minpt maxpt ss1 j lst ename1 obj1 sary ubnd len1 
                maxVpt minVpt vpts k len2 p1 p2
               ) 
  (prompt "\n LINE, POLYLINE Jbg CIRCLE,ELLIPSE,LWPOLYLINE,SPLINE 𕔕ƂɑI : ")
  (if (setq ss (ssget '((0 . "CIRCLE,ELLIPSE,LWPOLYLINE,SPLINE")))) 
    (progn 
      (setvar "cmdecho" 0)
      (command "_undo" "be")
      (setq len (sslength ss)
            i   0
      )
      (repeat len 
        (setq ename (ssname ss i)
              Obj   (vlax-ename->vla-object ename)
        )
        (if obj  ;; 2024.05.04
          (progn 
            (vla-getboundingbox Obj 'minVpt 'maxVpt)
            (setq minPt (vlax-safearray->list minVpt))
            (setq maxPt (vlax-safearray->list maxVpt))
          )
        )
        ;;(command "_rectang" "none" minpt "none" maxpt)
        (if 
          (and obj (setq ss1 (ssget "C" minpt maxpt '((0 . "LINE,LWPOLYLINE")))))
          (progn 
            (setq len1 (sslength ss1)
                  j    0
            )
            ;;(princ len1)
            (repeat len1 
              (setq ename1 (ssname ss1 j))
              (if (not (equal ename ename1)) 
                (progn 
                  (setq obj1 (vlax-ename->vla-object ename1))
                  ;; LINE, POLYLINE ̉_
                  (setq vpts (vla-intersectwith obj obj1 acExtendOtherEntity))
                  ;;(setq vpts (vla-intersectwith obj obj1 acExtendThisEntity))
                  (setq sary (vlax-variant-value vpts)
                        ubnd (vlax-safearray-get-u-bound sary 1)
                  )
                  ;;(princ "\nubnd=")(princ ubnd)
                  (if (>= ubnd 2) 
                    (if (setq lst (ifs_3dplist (vlax-safearray->list sary))) 
                      (progn 
                        (setq len2 (length lst)
                              p1   nil
                              p2   nil
                        )
                        (if (= len2 2) 
                          (setq p1 (car lst)
                                p2 (cadr lst)
                          )
                          (if (> len2 2) 
                            (progn 
                              (setq p1 (car lst)
                                    k  1
                              )
                              (while (and (not p2) (< k len2)) 
                                (if (not (equal p1 (nth k lst) 0.001)) 
                                  (setq p2 (nth k lst))
                                )
                                (setq k (1+ k))
                              )
                            )
                          )
                        )
                        (if (and p1 p2) 
                          (progn 
                            ;;(command "_circle" p1 0.01)(command "_circle" p2 0.01)
                            (command "_break" ename1 "none" p1 "none" p2)
                          )
                        )
                      )
                    )
                  )
                  (setq j (1+ j))
                )
              )
            )
          )
        )
        (setq i (1+ i))
      )
      (command "_undo" "end")
      (setvar "cmdecho" 1)
    )
  )
  (princ)
)

;; Polyline 𕪉ASPLINE. ELLIPSE 폜
;; LINE ݂̂̃XgԂ ARC ͂̂܂
(defun explodePolyline (ss / len i ename vlobj lst obj lnlst objname) 
  (if ss
    (progn 
      (setq len (sslength ss)
            i   0
      )
      (repeat len 
        (setq ename (ssname ss i))
        (setq vlobj (vlax-ename->vla-object ename))
        (setq objname (vla-get-ObjectName vlobj))
        (cond 
          ((= "AcDbPolyline" objname)
            (progn 
              (setq lst (vlax-safearray->list (vlax-variant-value (vla-Explode vlobj))))
              (foreach obj lst 
                (if (= (vla-get-ObjectName obj) "AcDbLine") 
                  (setq lnlst (append lnlst (list (vlax-vla-object->ename obj))))
                )
              )
              (entdel ename)
            )
          )
          ((= "AcDbLine" objname)
            (setq lnlst (append lnlst (list ename)))
          )
          ((= "AcDbSpline" objname)
            (entdel ename)
          )
          ((= "AcDbEllipse" objname)
            (entdel ename)
          )
        )
        (setq i (1+ i))
      )
    )
  )
  lnlst
)

;; pdfLine ŏłȂdۂ|CP{̐ɕϊ
;; SPLINE, ELLIPSE ͖ō폜̂ŁAƂɑI
(defun c:oneLine ( / fuz dif ss lst len i j ename1 ent1 ename2 ent2 p1 p2 p3 p4 v1 v2
             dist mp1 mp2 loop ss2 lnlst kp1 kp2
            e1 e2) 
  (setq fuz 10e-3
        dif 0.8
  )
  (setq ss2 (ssadd))
  (setvar "cmdecho" 0)
  (command "_undo" "be")

  (if (setq ss (ssget '((0 . "LINE,*POLYLINE,SPLINE,ELLIPSE")))) 
    (setq lnlst (explodePolyline ss))
  )
  ;;(princ lnlst)
  (if lnlst 
    (progn 
      (setq len (length lnlst) i 0)
      (if (> len 1) 
        (progn 
          ;; ̒Ƀ\[g
          (repeat len 
            (setq ename1 (nth i lnlst)
                  ent1   (entget ename1)
            )
            (setq p1 (cdr (assoc 10 ent1))
                  p2 (cdr (assoc 11 ent1))
            )
            (setq dist (distance p1 p2))
            (if (>= dist dif) 
              (setq lst (append lst (list (list ename1 dist))))
              ;; ͍폜
              (entdel ename1)
            )
            (setq i (1+ i))
          )
          (if lst 
            (progn
              ;; ̒Ƀ\[g
              (setq lst (vl-sort lst (function (lambda (e1 e2) (> (cadr e1) (cadr e2))))))
              (setq len (length lst)
                    i   0
              )
              (repeat (1- len) 
                (setq ename1 (car (nth i lst))
                      ent1   (entget ename1)
                )
                (setq p1 (cdr (assoc 10 ent1))
                      p2 (cdr (assoc 11 ent1))
                )
                (setq v1 (vector p1 p2))

                (setq j    (1+ i)
                      loop T
                )
                (while (and loop (< j len)) 
                  (setq ename2 (car (nth j lst))
                        ent2   (entget ename2)
                  )
                  (setq p3 (cdr (assoc 10 ent2))
                        p4 (cdr (assoc 11 ent2))
                  )
                  (setq v2 (vector p3 p4))
                  ;; QsŁAςłȂ
                  (if 
                    (and (isParallel v1 v2 fuz) 
                         (not (ssmemb ename1 ss2))
                         (not (ssmemb ename2 ss2))
                    )
                    (progn
                      (setq mp1 (midPoint p1 p2))
                      (setq mp2 (midPoint p3 p4))
                      (setq kp2 (tanPoint mp1 p3 p4))
                      (setq kp1 (tanPoint mp2 p1 p2))
                      (if (and kp1 kp2
                               ;; ݂ɐ_ł邩
                               (equal (distance p1 p2)(+ (distance p1 kp1)(distance p2 kp1)) fuz)
                               (equal (distance p3 p4)(+ (distance p3 kp2)(distance p4 kp2)) fuz))
                        (progn 
                          (setq dist (distance mp1 kp2))
                          (if (and (> dif dist) (> dist fuz)) 
                            (progn 
                              (if (not (inters p1 p3 p2 p4 T)) 
                                (progn 
                                  (setq mp1 (midPoint p1 p3))
                                  (setq mp2 (midPoint p2 p4))
                                  (setq ent2 (subst (cons 10 mp1)(assoc 10 ent2) ent2))
                                  (setq ent2 (subst (cons 11 mp2)(assoc 11 ent2) ent2))
                                  (entmod ent2)
                                  (entdel ename1)
                                  (setq ss2 (ssadd ename2 ss2))
                                  (setq loop nil)
                                )
                                (if (not (inters p1 p4 p2 p3 T)) 
                                  (progn 
                                    (setq mp1 (midPoint p1 p4))
                                    (setq mp2 (midPoint p2 p3))
                                    (setq ent2 (subst (cons 10 mp1)(assoc 10 ent2) ent2))
                                    (setq ent2 (subst (cons 11 mp2)(assoc 11 ent2) ent2))
                                    (entmod ent2)
                                    (entdel ename1)
                                    (setq ss2 (ssadd ename2 ss2))
                                    (setq loop nil)
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                    
                  )
                  (setq j (1+ j))
                )
                (setq i (1+ i))
              )
            )
          )
        )
      )
    )
  )
 
  (command "_undo" "end")
  (setvar "cmdecho" 1)
  (princ)
)

;; 2_Ԓ_
(defun midPoint (p1 p2 / x) 
  (mapcar '(lambda (x) (/ x 2.0)) (mapcar '+ p1 p2))
)

;; xNg̓(XJ[)
(defun vecScalar (v1 v2) 
  (apply '+ (mapcar '* v1 v2))
)

;; _ p0  p1-p2 ւ̐̌_
(defun tanPoint (p0 p1 p2 / vec x) 
  (setq vec (mapcar '- p2 p1))
  (mapcar '+ 
          p1
          (mapcar 
            '(lambda (x) 
               (* x 
                  (/ 
                    (- (vecScalar p0 vec) (vecScalar p1 vec))
                    (expt (distance p1 p2) 2)
                  )
               )
             )
            vec
          )
  )
)

;; 2_̒PʃxNg
(defun vector (p1 p2 / x) 
  (mapcar '(lambda (x) (/ x (distance p1 p2))) (mapcar '- p2 p1))
)

;; XgE](P炷)
(defun lstRotateR (lst /) 
  (append (list (last lst)) (reverse (cdr (reverse lst))))
)

; Xg](P炷)
(defun lstRotateL (lst /) 
  (append (cdr lst) (list (car lst)))
)

;; xNgs
(defun isParallel (v1 v2 fuz / x y) 
  (equal 
    (apply '+ 
           (mapcar '(lambda (x y) (abs (- x y))) 
                   (mapcar '* v1 (lstRotateR v2))
                   (mapcar '* (lstRotateR v1) v2)
           )
    )
    0.0
    fuz
  )
)

;; XvC 2024.01.17b
; (defun c:splinexx(/ ss)
;   (if (setq ss (ssget '((0 . "SPLINE"))))
;     (command "_DELETE" ss "")
;   )
;   (princ)
; )
;;; MText 𕪉āAText ̃XgԂ
(defun explodeMText( ss / txlst len i ename objname elast ent)
  (if ss
    (progn 
      (setq len (sslength ss) i 0)
      ;;(princ "\nlen=")(princ len)
      (repeat len 
        (setq ename (ssname ss i))
        (setq ent (entget ename))
        (setq objname (cdr (assoc 0 ent)))
        ;;(princ objname)
        (cond 
          ((= "MTEXT" objname)
            (progn 
              (setq elast (entlast))
              (setvar "cmdecho" 0)
              (command "_explode" ename "" "")
              (while (and elast (entnext elast))
                (setq txlst (append txlst (list (entnext elast))))
                (setq elast (entnext elast))
              )
            )
          )
          ((= "TEXT" objname)
            (setq txlst (append txlst (list ename)))
          )
        )
        (setq i (1+ i))
      )
    )
  )
  txlst
)

;; ŝԂ؂ TEXT. MTEXT  (PDF쐬p) 
;; sԊuATCYقړ TEXT 
;;  TEXT ̐F͐Fɕς
;; MTEXT ͕(EXPLODE) TEXT ɕϊ
(defun c:txlines( / cnt cnt2 ename ent i len lst ss 
    txh txhmax y ylst xmin xmax x x2 box p10 p1 ss2 str 
    e1 e2 ename2 ename3 ent2 j k len3 len2 lst2 ent3 lncnt ss3
    kw p3 txlst)
  (setq cnt 0 len 0 cnt2 0 txhmax 0.0 lst nil ylst nil lncnt 0)
  (setq ss3 (ssadd))
  (setvar "cmdecho" 0)
  (command "_undo" "be")
  
  (prompt "\n TEXT, MTEXT I܂.")
  (if (setq ss (ssget '((0 . "*TEXT"))))
    (setq txlst (explodeMText ss))
  )
  ;;(princ (length txlst))
  (if txlst
    (progn
      (setq ss nil ss (ssadd))
      (setq len (length txlst) i 0)
      (repeat len
        (setq ename (nth i txlst) ent (entget ename))
        (setq ss (ssadd ename ss))
        (setq box (ifs_textBox2Off ent 0.0))
        (setq x2 (car (cadr box)))
        (setq p10 (cdr (assoc 10 ent)))
        (setq x (car p10) y (cadr p10))
        (if (or (not xmin)(< x xmin))
          (setq xmin x)
        )
        (if (or (not xmax)(> x2 xmax))
          (setq xmax x2)
        )
        (if (> (setq txh (cdr (assoc 40 ent))) txhmax)
          (setq txhmax txh)
        )
        (setq lst (append lst (list y)))
        (setq i (1+ i))
      )
      (setq lst (vl-sort lst '>))
    )
    (progn
      (princ "TEXT, MTEXT ͂܂.")
    )
  )
  ;;(princ lst)
  (if lst
    (progn
      (setq len (length lst) i 1 y (car lst) ylst (list y))
      ;;(princ "\nylst0=")(princ ylst)
      (if (> len 1)
        (progn
          (repeat (1- len)
            (if (< (nth i lst) (- y txhmax))
              (setq y (nth i lst) ylst (append ylst (list y)))
            )
            (setq i (1+ i))
          )
          ;;(princ "\nylst1=")(princ ylst)
          (setq len (length ylst) i 0)
          (repeat len
            (setq y (nth i ylst))
            (setq p1 (list xmin y))
            (setq p3 (list xmax (+ y (* txhmax 0.8))))
            ;; Fence ł "-" P̂ƂA擾łȂ
            (if (setq ss2 (ssget "C" p1 p3 '((0 . "TEXT"))))
              (progn
                (setq len2 (sslength ss2) j 0 lst2 nil)
                (if (> len2 1)
                  (progn
                    (repeat len2
                      (setq ename2 (ssname ss2 j) ent2 (entget ename2))
                      (if (ssmemb ename2 ss)
                        (progn
                          (setq x (car (cdr (assoc 10 ent2))))
                          (setq lst2 (append lst2 (list (list x ename2))))
                        )
                       )
                      (setq j (1+ j))                 
                    )
                    (setq lst2 (vl-sort lst2 (function (lambda (e1 e2) (< (car e1) (car e2))))))
                    (setq str "" len3 (length lst2) k 0)
                    (repeat len3
                      (setq ename3 (cadr (nth k lst2)))
                      (setq str (strcat str (cdr (assoc 1 (entget ename3)))))
                      (if (> k 0)
                        (entdel ename3)
                        (setq ss3 (ssadd ename3 ss3))
                      )
                      (setq k (1+ k))                      
                    )
                    (setq ent3 (entget (cadr (nth 0 lst2))))
                    (setq ent3 (subst (cons 1 str)(assoc 1 ent3) ent3))
                    ;;mF̂߂ɐF𐅐FɕύX
                    (setq ent3 (subst (cons 62 4)(assoc 62 ent3) ent3))
                    (entmod ent3)
                    (setq lncnt (1+ lncnt))
                  )
                )
              )
            )
            (setq i (1+ i))
          )
        )
        
      )
      (if (> lncnt 0)
        (progn
          (princ (strcat "\n" (itoa lncnt) " s TEXT ܂D"))
          (initget "Yes No")
          (setq kw (getkword "\nF𔒂ɕύX܂H [Yes(Y) /No(N)] < Y > : "))
          (if (and ss3 (/= kw "No"))
            (progn
              (setvar "cmdecho" 0)
              (command "_CHPROP" ss3 "" "c" 7 "")
              ;;(setvar "cmdecho" 1)
            )
          )
        )
        (progn
          (princ "\n TEXT ͂܂D")
        )
      )
    )
  )
  (command "_undo" "end")
  (setvar "cmdecho" 1)
  (princ)
)

;; eLXg͂` 4 _擾 _獶
(defun ifs_textBox2Off ( textent offset / of txbox ang sinrot cosrot t1 t2 p0 p1 p2 p3 p4)
  (setq of (list offset offset 0.0))
  (setq p0 (cdr  (assoc 10 textent))) 
  (setq ang (cdr (assoc 50 textent)))
  (setq sinrot (sin ang) cosrot (cos ang))
  (if (setq txbox  (textbox textent))
    (progn
      ;;(princ "\nbox=")(princ txbox)
      (setq t1 (car  txbox) t2 (cadr txbox))
      (setq t1 (mapcar '- t1 of) t2 (mapcar '+ t2 of))
      (setq p1 (list 
            (+ (car  p0)(- (* (car t1) cosrot)(* (cadr t1) sinrot)))
            (+ (cadr p0)(+ (* (car t1) sinrot)(* (cadr t1) cosrot)))
          ))
      (setq p2 (list
            (+ (car  p0)(- (* (car t2) cosrot)(* (cadr t1) sinrot)))
            (+ (cadr p0)(+ (* (car t2) sinrot)(* (cadr t1) cosrot)))
          ))
      (setq p3 (list
            (+ (car  p0)(- (* (car t2) cosrot)(* (cadr t2) sinrot)))
            (+ (cadr p0)(+ (* (car t2) sinrot)(* (cadr t2) cosrot)))
          ))
      (setq p4 (list
            (+ (car  p0)(- (* (car t1) cosrot)(* (cadr t2) sinrot)))
            (+ (cadr p0)(+ (* (car t1) sinrot)(* (cadr t2) cosrot)))
          ))
      (list p1 p2 p3 p4)
    )
    (progn
      ;;(princ "\ntextbox 擾G[")
      nil
    )
  )
)

; (defun c:importPDF( / pdfname pageno scale)
;   (defun my_error(msg)
;     (princ (strcat "\n" msg))
;     (setvar "filedia" 1)
;     (setvar "users5" "")
;     (setvar "useri5" 0)
;     (setvar "userr5" 0)
;     (setq *error* nil)
;     (princ)
;   )
;   (setq *error* my_error)
;   (setq pdfname (getvar "users5"))
;   (setq pageno  (getvar "useri5"))
;   (setq scale   (getvar "userr5"))
;   (setvar "cmdecho" 1)
;   (setvar "filedia" 0)
;   (command "_pdfimport" "F" pdfname pageno pause scale 0)
;   (while (/= 0 (getvar "cmdactive"))
;     (command pause)
;   )
;   (setvar "filedia" 1)
;   ; (setvar "users5" "")
;   ; (setvar "useri5" 0)
;   ; (setvar "userr5" 0)
;   (setq *error* nil)
;   (princ)
; )
(princ "\nPDFAID.lsp 2024.09.06")
(princ) 
